This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 1067002 - Review Request: instack - installation tool for diskimage-builder style elements
Review Request: instack - installation tool for diskimage-builder style elements
Status: CLOSED UPSTREAM
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Steven Dake
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2014-02-19 08:48 EST by James Slagle
Modified: 2016-04-26 13:06 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-04-01 21:22:10 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
sdake: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description James Slagle 2014-02-19 08:48:45 EST
Spec URL:https://raw.github.com/agroup/tripleo-rpm-spec-files/master/instack/python-instack.spec
SRPM URL: http://repos.fedorapeople.org/repos/openstack-m/openstack-m/fedora-20/SRPMS/python-instack-0.0.1-1.fc20.src.rpm
Description: Instack is an installation tool for diskimage-builder style elements. It installs the the elements onto the running system, and can be used to install OpenStack locally from both diskimage-builder elements and
openstack-tripleo-image-elements.

Fedora Account System Username: slagle

koji scratch build: https://koji.fedoraproject.org/koji/taskinfo?taskID=6546846

This is one of my first package submissions for Fedora, and I need a sponsor. I have a few more package review requests that I'll be submitting for the other OpenStack TripleO related projects.
Comment 1 Steven Dake 2014-02-19 10:28:19 EST
James,

I'll sponsor you.

Please provide some links to other bugs where you have done package reviews in the past.
Comment 2 Steven Dake 2014-02-19 19:52:58 EST
James,

I recommend hosting this on stackforge so you can use the CI system.  This is relatively easy to setup.

Only libraries should begin their package name with the python-* prefix

The Release field should include the git short commit IIRC if you don't intend to use the upstream tagged tarball. (Doublecheck the packaging guidelines) Since you maintain it, I'd recommend just cutting a 0.0.2 version and using that for this package and drop the shortcommit entirely.

Make sure to run the spec, RPM, and SRPM through rpmlint first.

The rest looks good.  I'll provide a more thorough review after the package is renamed.

Regards,
-steve
Comment 3 James Slagle 2014-02-24 17:50:47 EST
Hi Steve, I've made some updates.

Spec URL:https://raw.github.com/agroup/tripleo-rpm-spec-files/master/instack/python-instack.spec
SRPM URL: http://repos.fedorapeople.org/repos/openstack-m/openstack-m/fedora-20/SRPMS/instack-0.0.2-1.fc20.src.rpm

I'll look into the stackforge suggestion as well.

One thing odd about this one is that when I run the spec file through rpmlint it is telling me:
[jslagle@localhost instack]$ rpmlint instack.spec 
instack.spec: W: invalid-url Source0: https://github.com/slagle/instack/releases/download/0.0.2/instack-0.0.2.tar.gz HTTP Error 403: Forbidden
0 packages and 1 specfiles checked; 0 errors, 1 warnings.

However, I can curl or wget that url just fine. Any suggestions on how to fix that?
Comment 4 James Slagle 2014-02-24 18:03:47 EST
The updated Spec for the rename is:

Spec URL: https://raw.github.com/agroup/tripleo-rpm-spec-files/master/instack/instack.spec
Comment 5 Steven Dake 2014-02-27 10:26:50 EST
James
Please provide both SPEC and SRPM in each change, since fedora-review uses the bugzilla information to operate

Regards
-=steve
Comment 7 Angus Thomas 2014-02-28 12:16:37 EST
Hi. I'm doing an unofficial review

On the spec file,  %{__python} and %{python_sitelib} are deprecated 
in favour of %{__python2} and %{python2_sitelib}

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Apache (v2.0)", "Unknown or generated". 1 files have unknown license.
     Detailed output of licensecheck in /tmp/instack/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[-]: Package uses nothing in %doc for runtime.
[x-]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[-]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build process.
[ ]: A package which is used by another package via an egg interface should
     provide egg info.
[!]: Package meets the Packaging Guidelines::Python
	
	See the note above about deprecated macros

[x]: Package contains BR: python2-devel or python3-devel
[-]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[!]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.

     Since you're the upsteam, this should be possible to arrange ;-)

[x]: Final provides and requires are sane (see attachments).
[ ]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[ ]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[-]: Package should compile and build into binary rpms on all supported
     architectures.
[ ]: %check is present and all tests pass.
[ ]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: instack-0.0.2-1.fc20.noarch.rpm
          instack-0.0.2-1.fc20.src.rpm
instack.noarch: W: spelling-error Summary(en_US) diskimage -> disk image, disk-image, disparage
instack.noarch: W: spelling-error %description -l en_US diskimage -> disk image, disk-image, disparage
instack.noarch: W: spelling-error %description -l en_US openstack -> open stack, open-stack, opens tack
instack.noarch: W: spelling-error %description -l en_US tripleo -> triple, triples, triplet
instack.noarch: W: no-manual-page-for-binary instack
instack.src: W: spelling-error Summary(en_US) diskimage -> disk image, disk-image, disparage
instack.src: W: spelling-error %description -l en_US diskimage -> disk image, disk-image, disparage
instack.src: W: spelling-error %description -l en_US openstack -> open stack, open-stack, opens tack
instack.src: W: spelling-error %description -l en_US tripleo -> triple, triples, triplet
instack.src: W: invalid-url Source0: https://github.com/slagle/instack/releases/download/0.0.2/instack-0.0.2.tar.gz HTTP Error 403: Forbidden
2 packages and 0 specfiles checked; 0 errors, 10 warnings.

	Not sure what caused this. The URL works OK with wget. Is this the intented cononical upsteam repo?

Rpmlint (installed packages)
----------------------------
# rpmlint instack
instack.noarch: W: spelling-error Summary(en_US) diskimage -> disk image, disk-image, disparage
instack.noarch: W: spelling-error %description -l en_US diskimage -> disk image, disk-image, disparage
instack.noarch: W: spelling-error %description -l en_US openstack -> open stack, open-stack, opens tack
instack.noarch: W: spelling-error %description -l en_US tripleo -> triple, triples, triplet
instack.noarch: W: no-manual-page-for-binary instack
1 packages and 0 specfiles checked; 0 errors, 5 warnings.
# echo 'rpmlint-done:'



Requires
--------
instack (rpmlib, GLIBC filtered):
    /bin/bash
    /usr/bin/python
    diskimage-builder
    python(abi)
    python-argparse



Provides
--------
instack:
    instack



Source checksums
----------------
https://github.com/slagle/instack/releases/download/0.0.2/instack-0.0.2.tar.gz :
  CHECKSUM(SHA256) this package     : 53835862d103256c7ba040324df6ef035cda52fcebea99a3f4b832b52f8fe267
  CHECKSUM(SHA256) upstream package : 53835862d103256c7ba040324df6ef035cda52fcebea99a3f4b832b52f8fe267


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review --rpm-spec -n /home/athomas/rpmbuild/SRPMS/instack-0.0.2-1.fc20.src.rpm
Buildroot used: fedora-20-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG
Comment 8 James Slagle 2014-03-12 13:59:55 EDT
Spec URL: https://raw.github.com/agroup/tripleo-rpm-spec-files/master/instack/instack.spec
SRPM URL: http://repos.fedorapeople.org/repos/openstack-m/openstack-m/fedora-20/SRPMS/instack-0.0.2-2.fc20.src.rpm

Thanks for the review Angus. I have updated based on your feedback.
Comment 9 Angus Thomas 2014-03-13 13:25:30 EDT
Hi James,

Apart from the incorrect date that rpmlint caught, this looks fine to me.

I'm not convinced this needs new RPM . There's no problem with the format of the 
changelog, just a non-impacting error in the date.


Angus


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Apache (v2.0)", "Unknown or generated". 1 files have unknown license.
     Detailed output of licensecheck in
     /home/athomas/Downloads/instack/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[ ]: Changelog in prescribed format.

	See rpmlint error below

[x]: Sources contain only permissible code or content.
[x]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[ ]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[-]: Package should compile and build into binary rpms on all supported
     architectures.
[ ]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: instack-0.0.2-2.fc20.noarch.rpm
          instack-0.0.2-2.fc20.src.rpm
instack.noarch: W: spelling-error Summary(en_US) diskimage -> disk image, disk-image, disparage
instack.noarch: W: spelling-error %description -l en_US diskimage -> disk image, disk-image, disparage
instack.noarch: W: spelling-error %description -l en_US openstack -> open stack, open-stack, opens tack
instack.noarch: W: spelling-error %description -l en_US tripleo -> triple, triples, triplet
instack.noarch: W: no-manual-page-for-binary instack
instack.src: W: spelling-error Summary(en_US) diskimage -> disk image, disk-image, disparage
instack.src: W: spelling-error %description -l en_US diskimage -> disk image, disk-image, disparage
instack.src: W: spelling-error %description -l en_US openstack -> open stack, open-stack, opens tack
instack.src: W: spelling-error %description -l en_US tripleo -> triple, triples, triplet
instack.src: E: specfile-error warning: bogus date in %changelog: Wed Mar 11 2014 James Slagle <jslagle@redhat.com> 0.0.2-2
2 packages and 0 specfiles checked; 1 errors, 9 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint instack
instack.noarch: W: spelling-error Summary(en_US) diskimage -> disk image, disk-image, disparage
instack.noarch: W: spelling-error %description -l en_US diskimage -> disk image, disk-image, disparage
instack.noarch: W: spelling-error %description -l en_US openstack -> open stack, open-stack, opens tack
instack.noarch: W: spelling-error %description -l en_US tripleo -> triple, triples, triplet
instack.noarch: W: no-manual-page-for-binary instack
1 packages and 0 specfiles checked; 0 errors, 5 warnings.
# echo 'rpmlint-done:'



Requires
--------
instack (rpmlib, GLIBC filtered):
    /bin/bash
    /usr/bin/python2
    diskimage-builder
    python(abi)
    python-argparse



Provides
--------
instack:
    instack



Source checksums
----------------
https://github.com/slagle/instack/releases/download/0.0.2/instack-0.0.2.tar.gz :
  CHECKSUM(SHA256) this package     : 53835862d103256c7ba040324df6ef035cda52fcebea99a3f4b832b52f8fe267
  CHECKSUM(SHA256) upstream package : 53835862d103256c7ba040324df6ef035cda52fcebea99a3f4b832b52f8fe267


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review --rpm-spec -n /home/athomas/rpmbuild/SRPMS/instack-0.0.2-2.fc20.src.rpm
Buildroot used: fedora-20-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG
Comment 11 Steven Dake 2014-03-18 13:37:26 EDT
James,

The invalid url can be fixed by reading:
https://fedoraproject.org/wiki/Packaging:SourceURL#Github

please fix that up, submit a new package, and I'll wrap up the review.

Thanks!
Comment 12 James Slagle 2014-03-18 16:56:36 EDT
Spec URL: https://raw.github.com/agroup/tripleo-rpm-spec-files/master/instack/instack.spec
SRPM URL: http://repos.fedorapeople.org/repos/openstack-m/openstack-m/fedora-20/SRPMS/instack-0.0.2-3.fc20.src.rpm

I did update the spec to build from our agroup repository on github as we've moved development over there instead of my personal github account.

I also read through https://fedoraproject.org/wiki/Packaging:SourceURL#Github

I am creating releases upstream in github: https://github.com/agroup/instack/releases/tag/0.0.2

So, I believe I shouldn't have to use github's automatic tarball creation mechanism, b/c I've instead created a release, and attached a .tar.gz to it for download.

I googled a bit about the error and found this:
https://bugzilla.redhat.com/show_bug.cgi?id=767739

I suspected github was throwing 403 on HEAD requests as well, and that does seem to be the case:
/usr/bin/curl -L --head https://github.com/agroup/instack/releases/download/0.0.2/instack-0.0.2.tar.gz
<snip>
HTTP/1.1 403 Forbidden

What do you think, is this safe to ignore? It seems to be a bug in either github and/or rpmlint.
Comment 13 Steven Dake 2014-03-19 20:14:48 EDT
James,

I'm not really sure to be honest.  I guess we will just have to let the github issue pass.

Comment #12 package APPROVED.
Comment 14 James Slagle 2014-03-20 15:21:33 EDT
New Package SCM Request
=======================
Package Name: instack
Short Description: installation tool for diskimage-builder style elements
Owners: slagle
Branches: f20
InitialCC:
Comment 15 Jon Ciesla 2014-03-20 16:09:09 EDT
Git done (by process-git-requests).

Note You need to log in before you can comment on or make changes to this bug.